Attribute VB_Name = "mdlColor"
Option Explicit

Public Function HSLtoRGB(ByVal h As Single, ByVal S As Single, ByVal l As Single) As Long
    Dim R As Long, G As Long, B As Long
    Dim var1 As Single, var2 As Single
    
    If S = 0 Then
        R = l * 255
        G = l * 255
        B = l * 255
    Else
        If l < 0.5 Then
            var2 = l * (S + 1)
        Else
            var2 = l + S - l * S
        End If
        var1 = 2 * l - var2
        
        R = 255 * HuetoRGB(var1, var2, h + 1 / 3)
        G = 255 * HuetoRGB(var1, var2, h)
        B = 255 * HuetoRGB(var1, var2, h - 1 / 3)
    End If
    
    HSLtoRGB = B * 65536 + G * 256 + R
End Function
    
Private Function HuetoRGB(ByVal m1 As Single, ByVal m2 As Single, ByVal h As Single) As Single
    If h < 0 Then h = h + 1
    If h > 1 Then h = h - 1
    
    If 6 * h < 1 Then
        HuetoRGB = m1 + (m2 - m1) * 6 * h
        Exit Function
    End If
    If 2 * h < 1 Then
        HuetoRGB = m2
        Exit Function
    End If
    If 3 * h < 2 Then
        HuetoRGB = m1 + (m2 - m1) * (2 / 3 - h) * 6
        Exit Function
    End If
    HuetoRGB = m1
End Function
