Attribute VB_Name = "modViewer"
Option Explicit

Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Boolean
Private Declare Function LoadImage Lib "user32" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Public hdcTiles(0 To 6) As Long, hbmpTiles(0 To 6) As Long, obmpTiles(0 To 6) As Long
Public hdcAtt1 As Long, hbmpAtt1 As Long, obmpAtt1 As Long
Public hdcAtt2 As Long, hbmpAtt2 As Long, obmpAtt2 As Long

Type Coordinate
    Map As Integer
    X As Byte
    Y As Byte
End Type

Type Map
    Number As Integer
    Name As String * 30
    Exits(0 To 3) As Integer
    Boot As Coordinate
    Flags As Byte
    Monsters(0 To 2) As Byte
    Layer(0 To 11, 0 To 11, 0 To 5) As Long
    Atts(0 To 11, 0 To 11, 0 To 1, 0 To 4) As Byte
    Darkness As Byte
    Weather As Byte
End Type

Type Monster
    Num As Byte
    X As Byte
    Y As Byte
    Dir As Byte
End Type

Public Maps() As Map
Public DrawBG As Boolean
Public AttLayer As Boolean
Public MouseX As Single, MouseY As Single

Public MapMonster(0 To 5) As Monster

Public Function Find(ByVal MapNumber As Long) As Long
    Dim i As Long
    
    For i = 0 To UBound(Maps)
        If Maps(i).Number = MapNumber Then
            Find = i
            Exit Function
        End If
    Next i
End Function

Public Function ConvertToMap(MapBuffer() As Byte) As Map
    Dim A As Integer, X As Integer, Y As Integer
    
    With ConvertToMap
        .Name = StrConv(Mid$(MapBuffer, 1, 15), vbUnicode)
        .Exits(0) = CInt(MapBuffer(36)) * 256 + MapBuffer(37)
        .Exits(1) = CInt(MapBuffer(38)) * 256 + MapBuffer(39)
        .Exits(2) = CInt(MapBuffer(40)) * 256 + MapBuffer(41)
        .Exits(3) = CInt(MapBuffer(42)) * 256 + MapBuffer(43)
        .Boot.Map = CInt(MapBuffer(44)) * 256 + MapBuffer(45)
        .Boot.X = MapBuffer(46)
        .Boot.Y = MapBuffer(47)
        .Flags = MapBuffer(48)
        .Monsters(0) = MapBuffer(49)
        .Monsters(1) = MapBuffer(51)
        .Monsters(2) = MapBuffer(53)
        For X = 0 To 11
            For Y = 0 To 11
                A = Y * 264 + X * 22 + 55
                .Layer(X, Y, 0) = CLng(MapBuffer(A)) * 256 + MapBuffer(A + 1)
                .Layer(X, Y, 2) = CLng(MapBuffer(A + 2)) * 256 + MapBuffer(A + 3)
                .Layer(X, Y, 3) = CLng(MapBuffer(A + 4)) * 256 + MapBuffer(A + 5)
                .Layer(X, Y, 4) = CLng(MapBuffer(A + 6)) * 256 + MapBuffer(A + 7)
                .Atts(X, Y, 0, 0) = MapBuffer(A + 8)
                .Atts(X, Y, 0, 1) = MapBuffer(A + 9)
                .Atts(X, Y, 0, 2) = MapBuffer(A + 10)
                .Atts(X, Y, 0, 3) = MapBuffer(A + 11)
                .Atts(X, Y, 0, 4) = MapBuffer(A + 12)
                .Layer(X, Y, 1) = CLng(MapBuffer(A + 13)) * 256 + MapBuffer(A + 14)
                .Layer(X, Y, 5) = CLng(MapBuffer(A + 15)) * 256 + MapBuffer(A + 16)
                .Atts(X, Y, 1, 0) = MapBuffer(A + 17)
                .Atts(X, Y, 1, 1) = MapBuffer(A + 18)
                .Atts(X, Y, 1, 2) = MapBuffer(A + 19)
                .Atts(X, Y, 1, 3) = MapBuffer(A + 20)
                .Atts(X, Y, 1, 4) = MapBuffer(A + 21)
            Next Y
        Next X
        .Darkness = MapBuffer(3223)
        .Weather = MapBuffer(3224)
    End With
End Function

Public Sub Draw(DrawMap As Map)
    Dim X As Long, Y As Long, i As Long, j As Long
    
    With frmMain
        If (DrawMap.Flags And 1) = 1 Then
            .lblMapName.ForeColor = RGB(0, 144, 192)
        ElseIf (DrawMap.Flags And 64) = 64 Then
            .lblMapName.ForeColor = vbRed
        Else
            .lblMapName.ForeColor = vbBlack
        End If
        
        If DrawMap.Number = 0 Then
            .lblMapName.Caption = "[" & RTrim(DrawMap.Name) & "]"
        Else
            .lblMapName.Caption = DrawMap.Number & " - [" & RTrim(DrawMap.Name) & "]"
        End If
        
        For i = 0 To 3
            .picExit(i).Visible = False
            .picExitD(i).Visible = False
            If DrawMap.Exits(i) > 0 Then
                If Find(DrawMap.Exits(i)) = 0 Then
                    .picExitD(i).Visible = True
                    .picExitD(i).ToolTipText = "Map: " + Str(DrawMap.Exits(i))
                Else
                    .picExit(i).Visible = True
                    .picExit(i).ToolTipText = "Map: " + Str(DrawMap.Exits(i))
                End If
            End If
        Next i
        
        If DrawMap.Boot.Map = 0 Then
            .lblBoot.Visible = False
        Else
            .lblBoot = "Boot Location: [" & DrawMap.Boot.Map & ", " & DrawMap.Boot.X & ", " & DrawMap.Boot.Y & "]"
            .lblBoot.Visible = True
        End If
        
        If DrawMap.Monsters(0) = 0 And DrawMap.Monsters(0) = 0 And DrawMap.Monsters(0) = 0 Then
            .lblMonsters.Caption = "Monsters: None"
        Else
            .lblMonsters.Caption = "Monsters: "
            If (DrawMap.Flags And 16) = 16 Then
                For i = 0 To 2
                    If DrawMap.Monsters(i) > 0 Then .lblMonsters.Caption = .lblMonsters.Caption & DrawMap.Monsters(i) & ", " & DrawMap.Monsters(i) & ", "
                Next i
            Else
                For i = 0 To 2
                    If DrawMap.Monsters(i) > 0 Then .lblMonsters.Caption = .lblMonsters.Caption & DrawMap.Monsters(i) & ", "
                Next i
            End If
            .lblMonsters.Caption = Mid$(.lblMonsters.Caption, 1, Len(.lblMonsters.Caption) - 2)
        End If
        
        If (DrawMap.Weather And 1) = 1 Then
            .lblWeather(0).Visible = True
        Else
            .lblWeather(0).Visible = False
        End If
        If (DrawMap.Weather And 2) = 2 Then
            .lblWeather(1).Visible = True
        Else
            .lblWeather(1).Visible = False
        End If
        If (DrawMap.Weather And 4) = 4 Then
            .lblWeather(2).Visible = True
        Else
            .lblWeather(2).Visible = False
        End If
        
        .lblDarkness.Caption = "Darkness: " & DrawMap.Darkness
        
        .picBox.Cls
        For X = 0 To 11
            For Y = 0 To 11
                For i = 0 To 5
                    If .chkLayer(i).Value = 1 And (i <> 3 Or DrawBG = True) And DrawMap.Layer(X, Y, i) > 0 Then
                        If DrawMap.Layer(X, Y, i) < 30000 Then
                            TransparentBlt .picBox.hdc, X * 32, Y * 32, 32, 32, hdcTiles(DrawMap.Layer(X, Y, i) \ 10000), ((DrawMap.Layer(X, Y, i) Mod 10000 - 1) Mod 7) * 32, (DrawMap.Layer(X, Y, i) Mod 10000 - ((DrawMap.Layer(X, Y, i) Mod 10000 - 1) Mod 7 + 1)) * 32 / 7, 32, 32, vbBlack
                        Else
                            TransparentBlt .picBox.hdc, X * 32, Y * 32, 32, 32, hdcTiles(DrawMap.Layer(X, Y, i) \ 5000 - 3), ((DrawMap.Layer(X, Y, i) Mod 5000 - 1) Mod 7) * 32, (DrawMap.Layer(X, Y, i) Mod 5000 - ((DrawMap.Layer(X, Y, i) Mod 5000 - 1) Mod 7 + 1)) * 32 / 7, 32, 32, vbBlack
                        End If
                    End If
                Next i
                If .chkLayer(6).Value = 1 Then TransparentBlt .picBox.hdc, X * 32, Y * 32, 32, 32, hdcAtt1, ((DrawMap.Atts(X, Y, 0, 0) - 1) Mod 7) * 32, (DrawMap.Atts(X, Y, 0, 0) - ((DrawMap.Atts(X, Y, 0, 0) - 1) Mod 7 + 1)) * 32 / 7, 32, 32, vbBlack
                If .chkLayer(7).Value = 1 Then TransparentBlt .picBox.hdc, X * 32, Y * 32, 32, 32, hdcAtt2, ((DrawMap.Atts(X, Y, 1, 0) - 1) Mod 7) * 32, (DrawMap.Atts(X, Y, 1, 0) - ((DrawMap.Atts(X, Y, 1, 0) - 1) Mod 7 + 1)) * 32 / 7, 32, 32, vbBlack
                
'                If DrawMap.Atts(X, Y, 0, 0) = 2 Then
'                    For i = 0 To 15
'                        For j = 0 To 15
'                            .picBox.PSet (X * 32 + i, Y * 32 + j), HSLtoRGB(DrawMap.Atts(X, Y, 0, 2) / 20, DrawMap.Atts(X, Y, 0, 3) / 12, DrawMap.Atts(X, Y, 0, 4) / 12)
'                        Next j
'                    Next i
'                End If
            Next Y
        Next X
        
        For i = 0 To 5
            If MapMonster(i).Num > 0 Then TransparentBlt .picBox.hdc, MapMonster(i).X * 32, MapMonster(i).Y * 32 - 16, 32, 32, .picSprite.hdc, 0, 0, 32, 32, vbBlack
        Next i
        
        .picBox.Line (MouseX - MouseX Mod 32, MouseY - MouseY Mod 32)-Step(31, 31), vbWhite, B
        .picBox.Refresh
    End With
End Sub

Public Sub LoadMCache(ByVal ServerName As String)
    Dim MapData(0 To 3299) As Byte, i As Long
    
    If Dir(App.Path & "\" & ServerName & "\mcache.dat") = "" Then Exit Sub
    
    ReDim Maps(0 To 0)
    frmMain.cmbWarp.Clear
    
    'Load map cache "mcache.dat"
    Open App.Path & "\" & ServerName & "\mcache.dat" For Random As #1 Len = 3300
    For i = 1 To 5000
        Get #1, i, MapData
        If MapData(0) > 0 Then
            ReDim Preserve Maps(0 To UBound(Maps) + 1)
            Maps(UBound(Maps)) = ConvertToMap(MapData)
            Maps(UBound(Maps)).Number = i
            If i < 10 Then
                frmMain.cmbWarp.AddItem "      " & i & " - [" & RTrim(Maps(UBound(Maps)).Name) & "]"
            ElseIf i < 100 Then
                frmMain.cmbWarp.AddItem "    " & i & " - [" & RTrim(Maps(UBound(Maps)).Name) & "]"
            ElseIf i < 1000 Then
                frmMain.cmbWarp.AddItem "  " & i & " - [" & RTrim(Maps(UBound(Maps)).Name) & "]"
            Else
                frmMain.cmbWarp.AddItem i & " - [" & RTrim(Maps(UBound(Maps)).Name) & "]"
            End If
        End If
    Next i
    Close #1
End Sub

Public Sub LoadTiles()
    Dim Pic As StdPicture
    
    If Val(frmMain.txtTileset.Text) = 0 Then
        If Dir(App.Path + "\Tiles.rsc") = "" Then Exit Sub
    Else
        If Dir(App.Path + "\Tiles" & Val(frmMain.txtTileset.Text) & ".rsc") = "" Then Exit Sub
    End If
    
    hdcTiles(0) = CreateCompatibleDC(0&)
    If Val(frmMain.txtTileset.Text) = 0 Then
        Set Pic = LoadPicture(App.Path + "\Tiles.rsc")
    Else
        If Len(Dir(App.Path + "\Tiles" & frmMain.txtTileset.Text & ".rsc")) > 0 Then
            Set Pic = LoadPicture(App.Path + "\Tiles" & frmMain.txtTileset.Text & ".rsc")
        Else
            MsgBox "Cannot find tiles" & frmMain.txtTileset.Text & ".rsc, using Tiles.rsc instead."
            Set Pic = LoadPicture(App.Path + "\Tiles.rsc")
        End If
    End If
    hbmpTiles(0) = Pic.Handle
    obmpTiles(0) = SelectObject(hdcTiles(0), hbmpTiles(0))
End Sub

Public Sub Initialize()
    Dim Pic As StdPicture
    
    AttLayer = False
    ReDim Maps(0 To 0)
    
    'Load Tiles into hdcTiles
    hdcTiles(0) = CreateCompatibleDC(0&)
    If Val(frmMain.txtTileset.Text) = 0 Then
        Set Pic = LoadPicture(App.Path + "\Tiles.rsc")
    Else
        If Len(Dir(App.Path + "\Tiles" & frmMain.txtTileset.Text & ".rsc")) > 0 Then
            Set Pic = LoadPicture(App.Path + "\Tiles" & frmMain.txtTileset.Text & ".rsc")
        Else
            MsgBox "Cannot find tiles" & frmMain.txtTileset.Text & ".rsc, using Tiles.rsc instead."
            Set Pic = LoadPicture(App.Path + "\Tiles.rsc")
        End If
    End If
    hbmpTiles(0) = Pic.Handle
    obmpTiles(0) = SelectObject(hdcTiles(0), hbmpTiles(0))
    
    hdcTiles(1) = CreateCompatibleDC(0&)
    Set Pic = LoadPicture(App.Path + "\tiles1.rsc")
    hbmpTiles(1) = Pic.Handle
    obmpTiles(1) = SelectObject(hdcTiles(1), hbmpTiles(1))
    
    hdcTiles(2) = CreateCompatibleDC(0&)
    Set Pic = LoadPicture(App.Path + "\tiles2.rsc")
    hbmpTiles(2) = Pic.Handle
    obmpTiles(2) = SelectObject(hdcTiles(2), hbmpTiles(2))
    
    If Len(Dir(App.Path + "\tilesindoor.rsc")) > 0 Then
        hdcTiles(3) = CreateCompatibleDC(0&)
        Set Pic = LoadPicture(App.Path + "\tilesindoor.rsc")
        hbmpTiles(3) = Pic.Handle
        obmpTiles(3) = SelectObject(hdcTiles(3), hbmpTiles(3))
    End If
    
    hdcTiles(4) = CreateCompatibleDC(0&)
    Set Pic = LoadPicture(App.Path + "\tilesoutdoor.rsc")
    hbmpTiles(4) = Pic.Handle
    obmpTiles(4) = SelectObject(hdcTiles(4), hbmpTiles(4))
    
    hdcTiles(5) = CreateCompatibleDC(0&)
    Set Pic = LoadPicture(App.Path + "\tilesground.rsc")
    hbmpTiles(5) = Pic.Handle
    obmpTiles(5) = SelectObject(hdcTiles(5), hbmpTiles(5))
    
    If Len(Dir(App.Path + "\tilesindoor.rsc")) > 0 Then
        hdcTiles(6) = CreateCompatibleDC(0&)
        Set Pic = LoadPicture(App.Path + "\tilesother.rsc")
        hbmpTiles(6) = Pic.Handle
        obmpTiles(6) = SelectObject(hdcTiles(6), hbmpTiles(6))
    End If
    
    'Load Atts into hdcAtt
    hdcAtt1 = CreateCompatibleDC(0&)
    Set Pic = LoadPicture(App.Path + "\Att1.rsc")
    hbmpAtt1 = Pic.Handle
    obmpAtt1 = SelectObject(hdcAtt1, hbmpAtt1)
        
    'Load Att2s into hdcAtt2
    hdcAtt2 = CreateCompatibleDC(0&)
    Set Pic = LoadPicture(App.Path + "\Att2.rsc")
    hbmpAtt2 = Pic.Handle
    obmpAtt2 = SelectObject(hdcAtt2, hbmpAtt2)
End Sub

Public Sub DeInitialize()
    Dim i As Byte
    For i = 0 To 6
        DeleteDC hdcTiles(i)
        DeleteObject hbmpTiles(i)
    Next i
    DeleteDC hdcAtt1
    DeleteObject hbmpAtt1
    DeleteDC hdcAtt2
    DeleteObject hbmpAtt2
End Sub
